Skip to navigation

An endpoint to subscribe to a benefit for a given instrument.

This endpoint will subscribe an instrument into the benefit identified by the given request parameters.

Authentication

X-AMEX-API-KEYstring
Application API key issued during app registration.
OR
Authorizationstring

HMAC (one-way TLS). A MAC authorization header signed with your client secret. See https://developer.americanexpress.com/documentation/api-security/hmac

OR
Authorizationstring

HMAC over mutual TLS. Requires a client certificate in addition to the signed MAC authorization header.

OR
AuthorizationBearer

OAuth 2.0 client credentials. Exchange your API key and secret for a bearer token, then send it as Authorization: Bearer <token>.

Headers

AuthorizationstringRequired

The Authorization header for the authentication at APIGEE. The following should be in the format of this header:

  • MAC id: The Partner's Client ID. The Client ID is generated during the Partner Onboarding and the App Registration.
  • ts: A client-generated timestamp (Unix Epoch format in milli-seconds).
  • nonce: A unique identifier string. The value of nonce must be unique for the each request.
  • mac: The request mac is generated using the HMAC SHA256 algorithm. Use the Client Secret to generate a hash/signature. The Client ID and Client Secret is generated during the Partner Onboarding and App registration.

e.g., MAC id="adc3af10-7bf6-4d8a-87ea-35519ff6e1ad",ts="1466548572491",nonce="be3bd46c-b052-4ae8-9f61-993635e5bc98",bodyhash="cRPVGQWU+89HNR0ASAJFjhKqDF9X0pApGYuC/NVQNEU=",mac="NqbqNO3vSBwk6EE7pBi11DzvgLCh50IPAICCIWgjxYA="

correlation_idstringRequired

A unique identifier used to track the request. This is with the current debugging standard in mind to track the request end-to-end. This will be mainly passed by the originating server (if it's a Webapp) or empty in case of the direct browser/app calls.

e.g., GUID.

senderstringRequired

The sender contains the sender information.

e.g., Issuer or Service Provider.

keynamestringRequired

The value assigned to the key used to encrypt the payload. For HIPED operations, this value must start with 'MK'.

e.g., AA3434342323.

Request

This endpoint expects an object.
network_infoobjectRequired

An object containing the GNS-related information.

instrument_idstringRequired

A unique ID for an instrument that is internal to the Issuer.

e.g., GUID.

benefit_idstringOptional

A unique ID that is associated with the benefit. This field is only mandatory if the Issuer chooses not to use external_benefit_id.

e.g., mock_benefit_id_001.

external_benefitobjectOptional

The reference to a benefit set up in an external system. If Issuer chooses to use benefit_id from R42 then this field is not required.

e.g., A benefit from a GNS Issuer, such as the Express Company (EC).

program_account_idstringOptional

The Partner Account ID refers to the FFN.

e.g., The Hilton Honors or the BA Executive Club number of the Customer.

This is required to be sent by Network Loyalty GNS for the partners: Hilton, Radisson, Marriott.

demographicobjectOptional

This is required by Network Loyalty GNS. This contains all possible Customer data which can be sent by Network/Issuer to make a successful transfer.

NOTE: All the fields that follow are optional, as any Partner may have different mandatory fields. Typically, the API checks mandatory parameters from a specific program_name and validates the mandatory fields.

Response

Accepted the request for a subscription.

Errors

400
Bad Request Error
403
Forbidden Error
404
Not Found Error
409
Conflict Error
500
Internal Server Error